VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_find_circle_tangents_pointf"
   ClientHeight    =   4485
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4875
   LinkTopic       =   "Form1"
   ScaleHeight     =   4485
   ScaleWidth      =   4875
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The last point clicked.
Private Clicked As PointF

Private Sub Form_Load()
    Set Clicked = New PointF
    Clicked.X = -1
    Clicked.Y = -1
    Me.ScaleMode = vbPixels
End Sub

Private Sub Form_Resize()
    Me.Refresh
End Sub

' Save the clicked point.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Save the point.
    Clicked.X = X
    Clicked.Y = Y

    ' Redraw.
    Me.Refresh
End Sub

' Draw the circle, point, and tangent lines.
Private Sub Form_Paint()
Dim radius As Single
Dim center As PointF
Dim p1 As PointF
Dim p2 As PointF

    ' Draw the circle.
    If (ScaleWidth > ScaleHeight) Then
        radius = Me.ScaleHeight / 6
    Else
        radius = Me.ScaleWidth / 6
    End If
    Set center = New PointF
    center.X = Me.ScaleWidth - radius - 20
    center.Y = Me.ScaleHeight - radius - 20
    
    Me.Cls
    Me.FillColor = RGB(128, 128, 255)
    Me.FillStyle = vbFSSolid
    Me.Circle (center.X, center.Y), radius, vbBlue

    If (Clicked.X < 0) Then Exit Sub

    ' Find the tangents.
    If FindTangents(center, radius, Clicked, p1, p2) Then
        Me.Line (Clicked.X, Clicked.Y)-(p1.X, p1.Y), vbGreen
        Me.Line (Clicked.X, Clicked.Y)-(p2.X, p2.Y), vbGreen
    End If

    ' Draw the point.
    Me.FillColor = RGB(255, 128, 128)
    Me.Circle (Clicked.X, Clicked.Y), 3, vbRed
End Sub


